de.caff.generics

## Interface FloatIndexable

- All Superinterfaces:
    java.lang.Iterable<java.lang.Float>, PrimitiveFloatIterable, Sizeable
  All Known Subinterfaces:
    MutableFloatIndexable
  All Known Implementing Classes:
    FloatIndexable.Base, FloatPair, MutableFloatIndexable.Base

      public interface FloatIndexable
      extends PrimitiveFloatIterable, Sizeable

  Class which allows readonly access of raw floats by index.

  The `EMPTY` constant or `emptyIndexable()` method provide the same useful return value to indicate emptiness.

  Simple implementations should extend `FloatIndexable.Base` because that provides useful implementations for standard Object methods and implements `Comparable`.

  Since:
    July 7, 2020
  Author:
    Rammi
  See Also:
    `FastFloatSequenceSearch`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `FloatIndexable.Base` Abstract base class which provides useful implementations for `Object.equals(Object)`, `Object.hashCode()`, `Object.toString()`.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static FloatIndexable.Base` | `EMPTY` An empty indexable.
    `static FloatIndexable` | `SINGLE_0` Float indexable which contains the single value `0.0f`.

    - ### Fields inherited from interface de.caff.generics.PrimitiveFloatIterable

      `EMPTY_FLOAT_ITERATOR`

    - ### Fields inherited from interface de.caff.generics.Sizeable

      `NULL`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default void` | `addAllTo(java.util.Collection<? super java.lang.Float> collection)` Add all elements of this indexable to the given collection.
    `default int` | `addToArray(float[] array, int pos)` Add the content of this indexable to the given array.
    `default int` | `addToArray(float[] array, int arrayPos, int index, int length)` Add a part of the content of this indexable to the given array.
    `default FloatIndexable.Base` | `asBase()` Make this float indexable usable as a class with defined standard Object methods.
    `default java.util.Collection<java.lang.Float>` | `asCollection()` Get a view on this indexable as an unmodifiable collection.
    `default DoubleIndexable.Base` | `asDoubleIndexable()` View this float indexable as a double indexable.
    `default Indexable<java.lang.Float>` | `asIndexable()` Get a view of this indexable as a standard object-based indexable.
    `default java.util.List<java.lang.Float>` | `asList()` Get a view on this indexable as an unmodifiable list.
    `static FloatIndexable.Base` | `based(FloatIndexable indexable)` Wrap any indexable with a based indexable which provides useful implementations for standard methods.
    `default int` | `binarySearch(float value)` Do a binary search in an indexable ordered in natural ascending order.
    `default int` | `binarySearch(float value, FloatOrdering order)` Do a binary search in an ordered indexable.
    `static int` | `compare(FloatIndexable indexable1, FloatIndexable indexable2)` Compare two float indexables.
    `default java.util.PrimitiveIterator.OfDouble` | `doubleIterator()` Get an primitive double iterator.
    `static FloatIndexable.Base` | `emptyIndexable()` Get an empty indexable set.
    `static boolean` | `equal(FloatIndexable indexable1, FloatIndexable indexable2)` Are two float indexables equal?
    `static boolean` | `equal(FloatIndexable indexable1, FloatIndexable indexable2, FloatPredicate2 checker)` Are two float indexables equal?
    `static boolean` | `equal(FloatIndexable indexable1, java.lang.Object indexable2)` Are two float indexables equal?
    `static boolean` | `equalStandard(FloatIndexable indexable1, FloatIndexable indexable2)` Are two float indexables equal?
    `default int` | `firstMatch(FloatPredicate1 check)` Get the first index for which the given check is fulfilled.
    `default PrimitiveFloatIterator` | `floatIterator()` Get an primitive float iterator.
    `default PrimitiveFloatIterator` | `floatIterator(int from, int to)` Get a float iterator from the given sub set.
    `default float` | `foldLeft(float initialValue, FloatOperator2 foldOperation)` Go over all values and do a cumulative calculation.
    `default FloatIndexable` | `frozen()` Get a frozen version of this indexable.
    `float` | `get(int index)` Get the element at the given index.
    `default float` | `getMod(int index)` Get an element modulo size.
    `default float` | `gyt(int index)` Pythonesque get.
    `static int` | `hash(FloatIndexable indexable)` Calculate a hashcode for a float indexable.
    `default FloatIndexable.Base` | `headSet(int toIndex)` Create an indexable subset from the last elements of this indexable set.
    `default java.lang.Iterable<java.lang.Integer>` | `indexes()` Get the indexes of this indexable as an iterable range.
    `static FloatIndexable.Base` | `init(int size, float value)` Get a float indexable of a given size which always returns the same value.
    `static FloatIndexable` | `initByIndex(int size, IntToFloatFunction1 producer)` Get a float indexable of a given size which returns elements created by index.
    `default IntIndexable` | `intIndexes()` Get the indexes of this indexable as an integer indexable.
    `default boolean` | `isEmpty()` Is this indexable empty?
    `default boolean` | `isOrdered(FloatOrdering order)` Is this indexable sorted according to the given ordering?
    `default boolean` | `isStrictlyOrdered(FloatOrdering order)` Is this indexable strictly sorted according to the given ordering?
    `default java.util.Iterator<java.lang.Float>` | `iterator()` Returns an iterator over elements of type `T`.
    `default int` | `lastMatch(FloatPredicate1 check)` Get the last index for which the given check is fulfilled.
    `default java.util.ListIterator<java.lang.Float>` | `listIterator()` Returns a list iterator over elements of type `T`.
    `default int` | `nextMatch(int startIndex, FloatPredicate1 check)` Get the next index for which the given check is fulfilled.
    `default MutableFloatIndexable` | `ordered()` Create a (mutable) double indexable from the values of this indexable which is ordered in natural order.
    `default MutableFloatIndexable` | `ordered(FloatOrdering order)` Create a (mutable) float indexable from the values of this indexable which is ordered as defined by the given ordering.
    `default int` | `previousMatch(int startIndex, FloatPredicate1 check)` Get the previous index for which the given check is fulfilled.
    `default FloatIndexable.Base` | `reverse()` Get this indexable but with inverted order.
    `default FloatIndexable` | `rotated(int steps)` Get a rotated view of this float indexable.
    `static FloatIndexable.Base` | `singleton(float value)` View a single float value as a float indexable of size 1.
    `default FloatIndexable.Base` | `subSet(int fromIndex, int toIndex)` Get an indexable subset.
    `default FloatIndexable.Base` | `sybSet(int fromIndex, int toIndex)` Get an indexable subset.
    `default FloatIndexable.Base` | `tailSet(int fromIndex)` Create an indexable subset from the last elements of this indexable set.
    `default float[]` | `toArray()` Convert this indexable into a Java array.
    `default java.util.ArrayList<java.lang.Float>` | `toList()` Create a list from this float indexable.
    `static java.lang.String` | `toString(FloatIndexable indexable)` Create a string representation of the given indexable.
    `default <T> Indexable<T>` | `view(FloatFunction1<? extends T> mapper)` Return a mapped view on this float indexable.
    `static FloatIndexable.Base` | `viewArray(float... array)` View a float array as an Indexable.
    `static FloatIndexable.Base` | `viewArray(float[] array, int start, int length)` View part of a float array as an Indexable.
    `static <T> FloatIndexable.Base` | `viewArray(T[] array, ToFloatFunction<? super T> valueExtract)` View an object array as a float indexable.
    `default BooleanIndexable` | `viewAsBoolean(FloatPredicate1 convert)` View this indexable as a boolean indexable while using a conversion for each value.
    `default ByteIndexable` | `viewAsByte()` View this float indexable as a byte integer indexable.
    `default DoubleIndexable` | `viewAsDouble()` View this float indexable as a double indexable.
    `default IntIndexable` | `viewAsInt()` View this float indexable as a short integer indexable.
    `default LongIndexable` | `viewAsLong()` View this float indexable as a long integer indexable.
    `default ShortIndexable` | `viewAsShort()` View this float indexable as a short integer indexable.
    `static FloatIndexable.Base` | `viewByIndex(int size, IntToFloatFunction1 producer)` Get a float indexable of a given size which returns elements created by index.
    `static FloatIndexable.Base` | `viewIndexable(Indexable<? extends java.lang.Number> indexable)` View a generic Number indexable as float indexable.
    `static FloatIndexable.Base` | `viewIndexable(Indexable<? extends java.lang.Number> indexable, float nullFallback)` View a generic Number indexable as float indexable.
    `static <T> FloatIndexable.Base` | `viewIndexable(Indexable<T> indexable, ToFloatFunction<? super T> extractor)` View a generic indexable as a float indexable.
    `static FloatIndexable.Base` | `viewList(java.util.List<? extends java.lang.Number> list)` View a list as an Indexable.
    `static FloatIndexable.Base` | `viewList(java.util.List<? extends java.lang.Number> list, float nullValue)` View a list as an Indexable.
    `static <T> FloatIndexable.Base` | `viewList(java.util.List<T> list, ToFloatFunction<? super T> extractor)` View a generic list as a float indexable.
    `static FloatIndexable.Base` | `viewNumberArray(java.lang.Number... array)` View a Number array as an Indexable.
    `default FloatIndexable` | `viewOp(FloatOperator1 op)` View this float indexable transformed by an operator.
    `default FloatIndexable` | `withAppendedValue(float value)` Create a view with of this indexable with another value added at the end.
    `static FloatIndexable.Base` | `withCachedHash(FloatIndexable indexable)` Wrap an indexable with one which caches the hash value.
    `default FloatIndexable` | `withExchangedValueAt(int index, float value)` Create a view of this float indexable with an exchanged value.
    `default FloatIndexable` | `withInsertedValueAt(int index, float value)` Create a view of this float indexable with an inserted value.
    `default FloatIndexable` | `withRemovedValueAt(int index)` Create a view of this indexable with one value removed.
    `default FloatIndexable` | `withSwappedValuesAt(int index1, int index2)` Create a view of this float indexable with two values swapped.

    - ### Methods inherited from interface de.caff.generics.PrimitiveFloatIterable

      `asDoubleIterable, containsFloat, containsFloat, forEachFloat, forEachFloatFragile`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface de.caff.generics.Sizeable

      `size`

- - ### Field Detail

    - #### SINGLE_0

          static final FloatIndexable SINGLE_0

      Float indexable which contains the single value `0.0f`.

    - #### EMPTY

          @NotNull
          static final FloatIndexable.Base EMPTY

      An empty indexable.

  - ### Method Detail

    - #### get

          float get(int index)

      Get the element at the given index.
      Parameters:
        `index` - index between `0` and `size() - 1`
      Returns:
        element at the given index

    - #### gyt

          default float gyt(int index)

      Pythonesque get. This allows accessing elements from the back by using negative indexes, e.g. `-1` references the last element, `-2` its predecessor, and so on.
      Parameters:
        `index` - index between `-size()` and `size() - 1`
      Returns:
        element at the given index

    - #### getMod

          default float getMod(int index)

      Get an element modulo size.

      This maps the given `index` into the range of this indexable by applying a modulo `Sizeable.size()` operation. For empty indexable this will throw an `IndexOutOfBoundsException` as there is no possible index to get.

      Parameters:
        `index` - index, possibly out of range, possibly even negative for Pythonesque access
      Returns:
        element at the given, possibly modulated, index

    - #### reverse

          @NotNull
          default FloatIndexable.Base reverse()

      Get this indexable but with inverted order.
      Returns:
        a view to this indexable which accesses the elements in reverse order

    - #### isEmpty

          default boolean isEmpty()

      Is this indexable empty?
      Returns:
        `true`: there are no elements in this indexable
        `false`: this indexable has elements

    - #### doubleIterator

          @NotNull
          default java.util.PrimitiveIterator.OfDouble doubleIterator()

      Get an primitive double iterator.
      Returns:
        double iterator which iterates over this indexable

    - #### floatIterator

          @NotNull
          default PrimitiveFloatIterator floatIterator()

      Get an primitive float iterator.
      Specified by:
        `floatIterator` in interface `PrimitiveFloatIterable`
      Returns:
        `float` iterator which iterates over this indexable

    - #### floatIterator

          @NotNull
          default PrimitiveFloatIterator floatIterator(int from,
                                                                int to)

      Get a float iterator from the given sub set.
      Parameters:
        `from` - first index of iterator
        `to` - one past last index of iterator
      Returns:
        int iterator which iterates over the given part of this indexable

    - #### iterator

          @NotNull
          default java.util.Iterator<java.lang.Float> iterator()

      Returns an iterator over elements of type `T`.
      Specified by:
        `iterator` in interface `java.lang.Iterable<java.lang.Float>`
      Specified by:
        `iterator` in interface `PrimitiveFloatIterable`
      Returns:
        an Iterator.

    - #### listIterator

          @NotNull
          default java.util.ListIterator<java.lang.Float> listIterator()

      Returns a list iterator over elements of type `T`.
      Returns:
        a list iterator.

    - #### subSet

          @NotNull
          default FloatIndexable.Base subSet(int fromIndex,
                                                      int toIndex)

      Get an indexable subset. The subset includes indices `fromIndex` to `toIndex - 1`.
      Parameters:
        `fromIndex` - start index of sub set
        `toIndex` - index after last index
      Returns:
        indxable subset view of this indexable

    - #### sybSet

          @NotNull
          default FloatIndexable.Base sybSet(int fromIndex,
                                                      int toIndex)

      Get an indexable subset. This is the Pythonesque version which allows negative indexes.
      Parameters:
        `fromIndex` - start index of sub set
        `toIndex` - end index of sub set
      Returns:
        indexable subset view of this indexable set

    - #### tailSet

          @NotNull
          default FloatIndexable.Base tailSet(int fromIndex)

      Create an indexable subset from the last elements of this indexable set. This already allows Pythonesquew indexing.
      Parameters:
        `fromIndex` - index to start with, negative counts from the back
      Returns:
        indexable subset view of this indexable set

    - #### headSet

          @NotNull
          default FloatIndexable.Base headSet(int toIndex)

      Create an indexable subset from the last elements of this indexable set. This already allows Pythonesquew indexing.
      Parameters:
        `toIndex` - index one after the end (equal to the length of the returned set), negative counts from the back
      Returns:
        indexable subset view of this indexable set

    - #### view

          @NotNull
          default <T> Indexable<T> view(@NotNull
                                                 FloatFunction1<? extends T> mapper)

      Return a mapped view on this float indexable.
      Type Parameters:
        `T` - result type pf mapper
      Parameters:
        `mapper` - mapper
      Returns:
        mapped indexable

    - #### asCollection

          @NotNull
          default java.util.Collection<java.lang.Float> asCollection()

      Get a view on this indexable as an unmodifiable collection. This is especially useful for conversion to standard collection classes, eg for adding all elements via `Collection.addAll(Collection)`.
      Returns:
        collection view

    - #### asList

          @NotNull
          default java.util.List<java.lang.Float> asList()

      Get a view on this indexable as an unmodifiable list. This is especially useful for conversion to standard collection classes, eg for adding all elements via `Collection.addAll(Collection)`.
      Returns:
        collection view
      See Also:
        `toList()`

    - #### toList

          @NotNull
          default java.util.ArrayList<java.lang.Float> toList()

      Create a list from this float indexable. This creates an independent list to which the elements of this indexable are copied.
      Returns:
        list copy of this indexable
      See Also:
        `asList()`

    - #### addAllTo

          default void addAllTo(@NotNull
                                java.util.Collection<? super java.lang.Float> collection)

      Add all elements of this indexable to the given collection.
      Parameters:
        `collection` - collection to add to

    - #### asIndexable

          @NotNull
          default Indexable<java.lang.Float> asIndexable()

      Get a view of this indexable as a standard object-based indexable.
      Returns:
        indexable with non-null `Float` values

    - #### toArray

          @NotNull
          default float[] toArray()

      Convert this indexable into a Java array.
      Returns:
        array copy containing all values of this indexable

    - #### addToArray

          default int addToArray(@NotNull
                                 float[] array,
                                 int pos)

      Add the content of this indexable to the given array.
      Parameters:
        `array` - array where the content is added
        `pos` - position in the array where the content of this indexable is added
      Returns:
        array position after this indexable

    - #### addToArray

          default int addToArray(@NotNull
                                 float[] array,
                                 int arrayPos,
                                 int index,
                                 int length)

      Add a part of the content of this indexable to the given array.
      Parameters:
        `array` - array where the content is added
        `arrayPos` - position in hte array where the content is added
        `index` - start index of this indexable which is added first
        `length` - number of entries of this indexable added to the array
      Returns:
        array position after the added content

    - #### indexes

          @NotNull
          default java.lang.Iterable<java.lang.Integer> indexes()

      Get the indexes of this indexable as an iterable range.
      Returns:
        iterable indexes
      See Also:
        `intIndexes()`, `Range.indexes(int)`

    - #### intIndexes

          @NotNull
          default IntIndexable intIndexes()

      Get the indexes of this indexable as an integer indexable.
      Returns:
        indexes as integer indexable
      See Also:
        `indexes()`, `IntIndexable.rangeFromSize(int)`

    - #### asDoubleIndexable

          @NotNull
          default DoubleIndexable.Base asDoubleIndexable()

      View this float indexable as a double indexable.
      Returns:
        double indexable view

    - #### foldLeft

          default float foldLeft(float initialValue,
                                 @NotNull
                                 FloatOperator2 foldOperation)

      Go over all values and do a cumulative calculation.
      Parameters:
        `initialValue` - start value for the operation, will be returned if this iterable is empty
        `foldOperation` - operation applied to each value, will get the accumulated value as its first and the current element value as its second argument
      Returns:
        accumulated value, result of applying fold operation to all values of this indexable iteratively

    - #### withInsertedValueAt

          @NotNull
          default FloatIndexable withInsertedValueAt(int index,
                                                              float value)

      Create a view of this float indexable with an inserted value. Note that this is not efficient, but handy in certain situations where only 1 or a few values are inserted. Use `ExpandableDoubleIndexable` if you want to carry out more stuff like this.

      As this creates a view of this indexable, changes to this indexable might result in a disaster when using the returned indexable!

      Parameters:
        `index` - index where the value is inserted before the current index (not Pythonesque, because it is possible to add an value at `index == size()`, and it is expected that most insertion will happen at 0 or at the end)
        `value` - inserted value at that index
      Returns:
        a view of this indexable with 1 more value at the given index, all values beyond are moved one index forward
      See Also:
        `withAppendedValue(float)`

    - #### withAppendedValue

          @NotNull
          default FloatIndexable withAppendedValue(float value)

      Create a view with of this indexable with another value added at the end. Note that this is not efficient, but handy in certain situations where only 1 or a few items are added.
      Parameters:
        `value` - value to add
      Returns:
        indexable view of this indexable, with the given value added at the end, so size is larger by 1
      See Also:
        `withInsertedValueAt(int, float)`

    - #### withExchangedValueAt

          @NotNull
          default FloatIndexable withExchangedValueAt(int index,
                                                               float value)

      Create a view of this float indexable with an exchanged value. Note that this is not efficient, but handy in certain situations where only 1 or a few values are exchanged. Use `ExpandableDoubleIndexable` if you want to carry out more stuff like this.

      As this creates a view of this indexable, changes to this indexable could lead to unexpected results when using the returned indexable!

      Parameters:
        `index` - index where the element is exchanged, hiding the current element. (Pythonesque)
        `value` - exchanged value at that index
      Returns:
        a view of this indexable with 1 more element at the given index, all elements beyond are moved one index forward

    - #### withRemovedValueAt

          @NotNull
          default FloatIndexable withRemovedValueAt(int index)

      Create a view of this indexable with one value removed. Note that this is not efficient, but handy in certain situations where only one or a few values are removed.
      Parameters:
        `index` - index of the removed value (Pythonesque)
      Returns:
        a view of this indexable where the value at the given index is removed

    - #### withSwappedValuesAt

          @NotNull
          default FloatIndexable withSwappedValuesAt(int index1,
                                                              int index2)

      Create a view of this float indexable with two values swapped. Note that this is not efficient, but handy in certain situations where only a few items are swapped.
      Parameters:
        `index1` - index of the first value (Pythonesque)
        `index2` - index of the second value (Pythonesque)
      Returns:
        a view of this indexable where the first and second value have exchanged places

    - #### rotated

          @NotNull
          default FloatIndexable rotated(int steps)

      Get a rotated view of this float indexable. The returned indexable will show this indexable with rotated indexes. A positive `steps` will rotate left, i.e. any index will be accessed as if the number of steps is added before extraction (modulo length). E.g. a rotation of `-1` will return the last element when index `0` is requested, and the first element for index `1`.
      Parameters:
        `steps` - steps to rotate
      Returns:
        rotated view of this indexable, use `frozen()` to create an indexable which no longer depends on this one

    - #### viewOp

          @NotNull
          default FloatIndexable viewOp(@NotNull
                                                 FloatOperator1 op)

      View this float indexable transformed by an operator.
      Parameters:
        `op` - transforming operator
      Returns:
        view of this indexable with transformed values

    - #### viewAsDouble

          @NotNull
          default DoubleIndexable viewAsDouble()

      View this float indexable as a double indexable. This will expand the float values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        a double indexable view of this indexable

    - #### viewAsLong

          @NotNull
          default LongIndexable viewAsLong()

      View this float indexable as a long integer indexable. Note that this will usually result in a loss of precision and reduction of the numeric range. This will cast the float values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        a long indexable view of this indexable

    - #### viewAsInt

          @NotNull
          default IntIndexable viewAsInt()

      View this float indexable as a short integer indexable. Note that this will usually result in a loss of precision and reduction of the numeric range of the values. This will cast the float values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        an integer indexable view of this indexable

    - #### viewAsShort

          @NotNull
          default ShortIndexable viewAsShort()

      View this float indexable as a short integer indexable. Note that this will usually result in a loss of precision and severe reduction of the numeric range of the values. This will cast the float values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        a short integer indexable view of this indexable

    - #### viewAsByte

          @NotNull
          default ByteIndexable viewAsByte()

      View this float indexable as a byte integer indexable. Note that this will usually result in a loss of precision and severe reduction of the numeric range. This will cast the float values of this indexable on each request, use `frozen()` on the result to create an independent copy if this seems like a problem to you.
      Returns:
        a byte integer indexable view of this indexable

    - #### viewAsBoolean

          @NotNull
          default BooleanIndexable viewAsBoolean(@NotNull
                                                          FloatPredicate1 convert)

      View this indexable as a boolean indexable while using a conversion for each value.

      Use `frozen()` on the result to decouple it from this indexable.

      Parameters:
        `convert` - converter applied to each value of this indexable before it is returned from the resulting indexable
      Returns:
        boolean indexable view of this indexable

    - #### viewList

          @NotNull
          static FloatIndexable.Base viewList(@NotNull
                                                       java.util.List<? extends java.lang.Number> list)

      View a list as an Indexable. This requires a list of non-null numbers as a base.
      Parameters:
        `list` - list used as a base, required to have only non-null elements
      Returns:
        indexable view of the given list, so any changes of the list will be reflected by the returned Indexable

    - #### viewList

          @NotNull
          static FloatIndexable.Base viewList(@NotNull
                                                       java.util.List<? extends java.lang.Number> list,
                                                       float nullValue)

      View a list as an Indexable. This allows to provide a fallback for null elements in the list.
      Parameters:
        `list` - list used as a base, required to have only non-null elements
        `nullValue` - value returned for `null` elements in the list
      Returns:
        indexable view of the given list, so any changes of the list will be reflected by the returned Indexable

    - #### viewList

          @NotNull
          static <T> FloatIndexable.Base viewList(@NotNull
                                                           java.util.List<T> list,
                                                           @NotNull
                                                           ToFloatFunction<? super T> extractor)

      View a generic list as a float indexable.
      Type Parameters:
        `T` - element type of list
      Parameters:
        `list` - generic list
        `extractor` - extractor function which extracts a float from the elements of `list`
      Returns:
        a float indexable view of `list`

    - #### viewIndexable

          @NotNull
          static FloatIndexable.Base viewIndexable(@NotNull
                                                            Indexable<? extends java.lang.Number> indexable)

      View a generic Number indexable as float indexable.
      Parameters:
        `indexable` - generic indexable with Number elements, required to have only non-null elements
      Returns:
        float indexable view

    - #### viewIndexable

          @NotNull
          static FloatIndexable.Base viewIndexable(@NotNull
                                                            Indexable<? extends java.lang.Number> indexable,
                                                            float nullFallback)

      View a generic Number indexable as float indexable.
      Parameters:
        `indexable` - generic indexable with Number elements
        `nullFallback` - fallback for `null` elements
      Returns:
        float indexable view

    - #### viewIndexable

          @NotNull
          static <T> FloatIndexable.Base viewIndexable(@NotNull
                                                                Indexable<T> indexable,
                                                                @NotNull
                                                                ToFloatFunction<? super T> extractor)

      View a generic indexable as a float indexable.
      Type Parameters:
        `T` - element type of indexable
      Parameters:
        `indexable` - generic indexable
        `extractor` - extractor function which extracts a float from the elements of `indexable`
      Returns:
        a float indexable view of `indexable`

    - #### viewNumberArray

          @NotNull
          static FloatIndexable.Base viewNumberArray(@NotNull
                                                              java.lang.Number... array)

      View a Number array as an Indexable. To view only part of the array use `subSet(int, int)`.
      Parameters:
        `array` - array used as base, required to hold only non-null values
      Returns:
        indexable view of the given array, any changes to the underlying array will be reflected by the returned Indexable

    - #### viewArray

          @NotNull
          static FloatIndexable.Base viewArray(@NotNull
                                                        float... array)

      View a float array as an Indexable. To view only part of the array use `viewArray(float[], int, int)`.
      Parameters:
        `array` - array used as base
      Returns:
        indexable view of the given array, any changes to the underlying array will be reflected by the returned Indexable

    - #### viewArray

          @NotNull
          static FloatIndexable.Base viewArray(@NotNull
                                                        float[] array,
                                                        int start,
                                                        int length)

      View part of a float array as an Indexable.
      Parameters:
        `array` - array used as base
        `start` - index of first float to use from the array
        `length` - number of elements to use from the array
      Returns:
        indexable view of the given array, any changes to the underlying array will be reflected by the returned Indexable

    - #### viewArray

          @NotNull
          static <T> FloatIndexable.Base viewArray(@NotNull
                                                            T[] array,
                                                            @NotNull
                                                            ToFloatFunction<? super T> valueExtract)

      View an object array as a float indexable.
      Type Parameters:
        `T` - array element type
      Parameters:
        `array` - viewed array
        `valueExtract` - converter from array elements to the float values of this indexable
      Returns:
        indexable view of the given array, any changes to the underlying array will be reflected by the returned Indexable

    - #### singleton

          @NotNull
          static FloatIndexable.Base singleton(float value)

      View a single float value as a float indexable of size 1.
      Parameters:
        `value` - single value
      Returns:
        indexable with one value

    - #### init

          @NotNull
          static FloatIndexable.Base init(int size,
                                                   float value)

      Get a float indexable of a given size which always returns the same value.
      Parameters:
        `size` - size of the returned indexable
        `value` - value returned for each element
      Returns:
        indexable of size `size` with always the same element

    - #### viewByIndex

          @NotNull
          static FloatIndexable.Base viewByIndex(int size,
                                                          @NotNull
                                                          IntToFloatFunction1 producer)

      Get a float indexable of a given size which returns elements created by index. This will always call the `producer` when an element is requested. Use `frozen()` on the result to create an indexable which avoids this.
      Parameters:
        `size` - size of the returned indexable
        `producer` - producer which is called with an index and expected to return the associated value
      Returns:
        indexable view which calls the `producer` with the given index when an element is requested
      See Also:
        `initByIndex(int, IntToFloatFunction1)`

    - #### initByIndex

          @NotNull
          static FloatIndexable initByIndex(int size,
                                                     @NotNull
                                                     IntToFloatFunction1 producer)

      Get a float indexable of a given size which returns elements created by index. This will call the producer only once for each element during the call of this method, and return the results on later requests.
      Parameters:
        `size` - size of the returned indexable
        `producer` - producer which is called with an index and expected to return the associated value
      Returns:
        indexable with elements initialized by the `producer`
      See Also:
        `viewByIndex(int, IntToFloatFunction1)`

    - #### emptyIndexable

          @NotNull
          static FloatIndexable.Base emptyIndexable()

      Get an empty indexable set.
      Returns:
        empty indexable

    - #### toString

          @NotNull
          static java.lang.String toString(@NotNull
                                                    FloatIndexable indexable)

      Create a string representation of the given indexable.
      Parameters:
        `indexable` - indexable
      Returns:
        string representation

    - #### equal

          static boolean equal(@NotNull
                               FloatIndexable indexable1,
                               @NotNull
                               FloatIndexable indexable2)

      Are two float indexables equal?

      This handles NaN values specially so that two of them are considered equal, compare `FloatPredicate2.EQUAL_EVEN_NAN`.

      Parameters:
        `indexable1` - first indexable
        `indexable2` - second indexable
      Returns:
        `true` if both indexables contain the same values in the same sequence
        `false` if sizes or values differ

    - #### equalStandard

          static boolean equalStandard(@NotNull
                                       FloatIndexable indexable1,
                                       @NotNull
                                       FloatIndexable indexable2)

      Are two float indexables equal?

      This handles NaN values according to the standard so that two of them are considered non-equal, compare `FloatPredicate2.EQUAL_STANDARD`.

      Parameters:
        `indexable1` - first indexable
        `indexable2` - second indexable
      Returns:
        `true` if both indexables contain the same values in the same sequence
        `false` if sizes or values differ

    - #### equal

          static boolean equal(@NotNull
                               FloatIndexable indexable1,
                               @NotNull
                               FloatIndexable indexable2,
                               @NotNull
                               FloatPredicate2 checker)

      Are two float indexables equal?
      Parameters:
        `indexable1` - first indexable
        `indexable2` - second indexable
        `checker` - equality checker, this can be `FloatPredicate2.EQUAL_STANDARD` pr `FloatPredicate2.EQUAL_EVEN_NAN` which handle NaN differently, or allow for a small epsilon difference
      Returns:
        `true` if both indexables contain the same values as defined by the checker in the same sequence
        `false` if sizes or values differ

    - #### equal

          static boolean equal(@NotNull
                               FloatIndexable indexable1,
                               @Nullable
                               java.lang.Object indexable2)

      Are two float indexables equal? This is a convenience method which may be called from implementations for their `Object.equals(Object)` method.
      Parameters:
        `indexable1` - first indexable
        `indexable2` - object expected to be an indexable itself
      Returns:
        `true` if both indexables contain the same values in the same sequence
        `false` if the second object is not an indexable, of if sizes or values differ

    - #### compare

          static int compare(@NotNull
                             FloatIndexable indexable1,
                             @NotNull
                             FloatIndexable indexable2)

      Compare two float indexables. This compares the two indexables lexically element by element using `Float.compareTo(Float)` until either the first difference is found (smaller of the two values define the lower indexable) or the end of one is met (shorter indexable is less).
      Parameters:
        `indexable1` - first indexable
        `indexable2` - second indexable
      Returns:
        `< 0>` if `indexable1 < indxable2`, `0` if `indexable1 == indexable2`, or `> 0` if `indexable1 > indexable2`

    - #### hash

          static int hash(@NotNull
                          FloatIndexable indexable)

      Calculate a hashcode for a float indexable.
      Parameters:
        `indexable` - indexable for which the hash code is required
      Returns:
        hash code for the given indexable

    - #### withCachedHash

          @NotNull
          static FloatIndexable.Base withCachedHash(@NotNull
                                                             FloatIndexable indexable)

      Wrap an indexable with one which caches the hash value. This is useful if indexables are used as hash keys because hash value calculation is expensive.

      The wrapped indexable must not change after it is wrapped, otherwise strange things are expected to happen.

      Parameters:
        `indexable` - wrapped indexable, must not change
      Returns:
        indexable which forwards most methods to `indexable`, but also provides useful implementations for `Object.hashCode()`, `Object.equals(Object)`, and `Object.toString()`

    - #### nextMatch

          default int nextMatch(int startIndex,
                                @NotNull
                                FloatPredicate1 check)

      Get the next index for which the given check is fulfilled.
      Parameters:
        `startIndex` - start index for checking, `Pythonesque` indexing supported
        `check` - check to perform on elements of this indexable until `true`
      Returns:
        next index starting with `startIndex` for which the check returns `true`, `Pythonesque.UNMAPPABLE` if none

    - #### firstMatch

          default int firstMatch(@NotNull
                                 FloatPredicate1 check)

      Get the first index for which the given check is fulfilled.
      Parameters:
        `check` - check to perform on elements of this indexable until `true`
      Returns:
        first index for which the check returns `true`, `-1` if none

    - #### previousMatch

          default int previousMatch(int startIndex,
                                    @NotNull
                                    FloatPredicate1 check)

      Get the previous index for which the given check is fulfilled.
      Parameters:
        `startIndex` - start index for checking, `Pythonesque` indexing supported
        `check` - check to perform on elements of this indexable until `true`
      Returns:
        next index starting with `startIndex` for which the check returns `true`, `Pythonesque.UNMAPPABLE` if none

    - #### lastMatch

          default int lastMatch(@NotNull
                                FloatPredicate1 check)

      Get the last index for which the given check is fulfilled.
      Parameters:
        `check` - check to perform on elements of this indexable until `true`
      Returns:
        last index for which the check returns `true`, `-1` if none

    - #### frozen

          @NotNull
          default FloatIndexable frozen()

      Get a frozen version of this indexable.

      Often Indexables are used as a view to underlying collections. Although this interface is immutable, the underlying colelction might nevertheless change. This copies the current state of this indexable into an unmodifiable state, and returns an Indexable which is stable in size and will return always the same element for a given index. Beware: it is still possible that any element itself changes when the elements are mutable.

      Calling `frozen()` again on the returned object will just return the object itself, so you can safely call this method more than once.

      Returns:
        frozen version of this Indexable

    - #### isOrdered

          default boolean isOrdered(@NotNull
                                    FloatOrdering order)

      Is this indexable sorted according to the given ordering? This method tests that consecutive elements in this indexable or either ascending or the same, but never descending. See isStrictlyOrdered(FloatOrdering) for a stricter alternative.
      Parameters:
        `order` - expected ordering
      Returns:
        `true` if this indexable is sorted as defined by `order`
        `false` if not

    - #### isStrictlyOrdered

          default boolean isStrictlyOrdered(@NotNull
                                            FloatOrdering order)

      Is this indexable strictly sorted according to the given ordering? This method tests that consecutive elements in this indexable or strictly ascending or the same, but never descending. See isOrdered(FloatOrdering) for a more relaxed alternative.
      Parameters:
        `order` - expected ordering
      Returns:
        `true` if this indexable is sorted as defined by `order`
        `false` if not

    - #### binarySearch

          default int binarySearch(float value)

      Do a binary search in an indexable ordered in natural ascending order. This requires this indexable to be ordered in `standard ascending order`, i.e. isOrdered(FloatOrdering) has to return `true` for this ordering. For efficiency this prerequisite is not checked, but not fulfilling it will make this method return bogus results. If this indexable is only ordered, but not `strictly ordered` it is not defined which index is returned when the looked up value appears in a sequence of equal values.
      Parameters:
        `value` - value to look up
      Returns:
        a positive integer defining the index where the given value was found, and a negative integer if the value is not contained. The latter defines the insertion point where the looked up value would match into this sorted indexable in the form `-(insertIndex + 1)`.

    - #### binarySearch

          default int binarySearch(float value,
                                   @NotNull
                                   FloatOrdering order)

      Do a binary search in an ordered indexable. This requires this indexable to be ordered in non-descending order as defined by the given `order`, i.e. isOrdered(FloatOrdering) has to return `true` for this order. For efficiency this prerequisite is not checked, but not fulfilling it will make this method return bogus results. If this indexable is only ordered, but not `strictly ordered` it is not defined which index is returned when the looked up value appears in a sequence of equal values.
      Parameters:
        `value` - value to look up
        `order` - sort order
      Returns:
        a positive integer defining the index where the given value was found, and a negative integer if the value is not contained. The latter defines the insertion point where the looked up value would match into this sorted indexable in the form `-(insertIndex + 1)`.

    - #### ordered

          @NotNull
          default MutableFloatIndexable ordered(@NotNull
                                                         FloatOrdering order)

      Create a (mutable) float indexable from the values of this indexable which is ordered as defined by the given ordering.

      If natural ordering is required prefer calling `ordered()` because that typically runs 1.5 times faster.

      Parameters:
        `order` - sort order
      Returns:
        independent indexable with sorted values

    - #### ordered

          @NotNull
          default MutableFloatIndexable ordered()

      Create a (mutable) double indexable from the values of this indexable which is ordered in natural order.

      This can be some 1.5x faster than using `ordered(FloatOrdering)` with `natural order`.

      Returns:
        independent indexable with sorted values

    - #### asBase

          @NotNull
          default FloatIndexable.Base asBase()

      Make this float indexable usable as a class with defined standard Object methods.
      Returns:
        based version of this indexable

    - #### based

          @NotNull
          static FloatIndexable.Base based(@NotNull
                                                    FloatIndexable indexable)

      Wrap any indexable with a based indexable which provides useful implementations for standard methods.
      Parameters:
        `indexable` - indexable to wrap
      Returns:
        based indexable